#include <msp/core/except.h>
#include "inet.h"
#include "inet6.h"

namespace Msp {
namespace Net {

SockAddr *SockAddr::create(const sockaddr_storage &sa)
{
	switch(sa.ss_family)
	{
	case AF_INET:
		return new InetAddr(reinterpret_cast<const sockaddr_in &>(sa));
	case AF_INET6:
		return new Inet6Addr(reinterpret_cast<const sockaddr_in6 &>(sa));
	default:
		throw InvalidParameterValue("Unknown address family");
	}
}

unsigned SockAddr::fill_sockaddr(sockaddr_storage &sa) const
{
	return fill_sockaddr(reinterpret_cast<sockaddr &>(sa));
}

} // namespace Net
} // namespace Msp
